/* vim: set sw=8 ts=8 si : */
/*************************************************************************
 Title	:   C include file for analog conversion
 Target:    atmega88/168/328
 Copyright: GPL V2
***************************************************************************/
#ifndef ANALOG_H
#define ANALOG_H

// Define USE_INTERRUPT if you want 11/12 bit interrupt drive ADC with oversampling
#define USE_INTERRUPT 1
//#undef USE_INTERRUPT

// set this to 4 for 11bit and to 16 for 12bit:
#define OVERSAMPLE_CNT 4

#ifdef USE_INTERRUPT 
// You must first call adc_isr_on if you use the
// 11 or 12bit resoltion (getanalogresult function).
// Do not use interrupt driven ADC measurements with
// systems where the timing is critical (e.g DS18S20 sensors).
// The ISR(ADC_vect) interrupt function will mess up you timing
// too much.
extern void adc_isr_on(void);

// return analog value of a given channel.
// 11bit or 12bit with interrupt
extern uint16_t getanalogresult(uint8_t swchannel);
//
#else // USE_INTERRUPT
// 10bit no interrupt:
extern uint16_t convertanalog(unsigned char swchannel);
#endif // USE_INTERRUPT

#endif /* ANALOG_H */
